/*
 * ALSA SoC OMAP ABE driver
*
 * Author:          Laurent Le Faucheur <l-le-faucheur@ti.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */

#ifndef _ABE_TASKID_H_
#define _ABE_TASKID_H_

#define C_ABE_FW_TASK_DL1_APS_CORE                          0
#define C_ABE_FW_TASK_DL1_APS_COIL_CORE                     1
#define C_ABE_FW_TASK_DL2_L_APS_CORE                        2
#define C_ABE_FW_TASK_DL2_L_APS_COIL_CORE                   3
#define C_ABE_FW_TASK_DL2_R_APS_CORE                        4
#define C_ABE_FW_TASK_DL2_R_APS_COIL_CORE                   5
#define C_ABE_FW_TASK_ASRC_VX_DL_8                          6
#define C_ABE_FW_TASK_ASRC_VX_DL_16                         7
#define C_ABE_FW_TASK_ASRC_MM_DL                            8
#define C_ABE_FW_TASK_ASRC_VX_UL_8                          9
#define C_ABE_FW_TASK_ASRC_VX_UL_16                         10
#define C_ABE_FW_TASK_DC_REMOVAL                            11
#define C_ABE_FW_TASK_VX_UL_48_8_DEC                        12
#define C_ABE_FW_TASK_VX_UL_48_16_DEC                       13
#define C_ABE_FW_TASK_BT_DL_48_8_DEC                        14
#define C_ABE_FW_TASK_BT_DL_48_16_DEC                       15
#define C_ABE_FW_TASK_ECHO_REF_48_8_DEC                     16
#define C_ABE_FW_TASK_ECHO_REF_48_16_DEC                    17
#define C_ABE_FW_TASK_DL2_EQ                                18
#define C_ABE_FW_TASK_DL2_L_APS_IIR                         19
#define C_ABE_FW_TASK_DL2_R_APS_IIR                         20
#define C_ABE_FW_TASK_DL2_APS_EQ                            21
#define C_ABE_FW_TASK_ECHO_REF_48_16                        22
#define C_ABE_FW_TASK_ECHO_REF_48_8                         23
#define C_ABE_FW_TASK_GAIN_UPDATE                           24
#define C_ABE_FW_TASK_SideTone                              25
#define C_ABE_FW_TASK_VX_DL_8_48_LP                         26
#define C_ABE_FW_TASK_VX_DL_8_48_HP                         27
#define C_ABE_FW_TASK_VX_DL_16_48_LP                        28
#define C_ABE_FW_TASK_VX_DL_16_48_HP                        29
#define C_ABE_FW_TASK_VX_UL_48_8_LP                         30
#define C_ABE_FW_TASK_VX_UL_48_8_HP                         31
#define C_ABE_FW_TASK_VX_UL_48_16_LP                        32
#define C_ABE_FW_TASK_VX_UL_48_16_HP                        33
#define C_ABE_FW_TASK_BT_UL_8_48_LP                         34
#define C_ABE_FW_TASK_BT_UL_8_48_HP                         35
#define C_ABE_FW_TASK_BT_UL_16_48_LP                        36
#define C_ABE_FW_TASK_BT_UL_16_48_HP                        37
#define C_ABE_FW_TASK_BT_DL_48_8_LP                         38
#define C_ABE_FW_TASK_BT_DL_48_8_HP                         39
#define C_ABE_FW_TASK_BT_DL_48_16_LP                        40
#define C_ABE_FW_TASK_BT_DL_48_16_HP                        41
#define C_ABE_FW_TASK_ECHO_REF_48_8_LP                      42
#define C_ABE_FW_TASK_ECHO_REF_48_8_HP                      43
#define C_ABE_FW_TASK_ECHO_REF_48_16_LP                     44
#define C_ABE_FW_TASK_ECHO_REF_48_16_HP                     45
#define C_ABE_FW_TASK_DL1_EQ                                46
#define C_ABE_FW_TASK_DL1_APS_IIR                           47
#define C_ABE_FW_TASK_DL1_APS_EQ                            48
#define C_ABE_FW_TASK_IHF_48_96_LP                          49
#define C_ABE_FW_TASK_EARP_48_96_LP                         50
#define C_ABE_FW_TASK_DL1_GAIN                              51
#define C_ABE_FW_TASK_DL2_GAIN                              52
#define C_ABE_FW_TASK_IO_PING_PONG                          53
#define C_ABE_FW_TASK_IO_DMIC                               54
#define C_ABE_FW_TASK_IO_PDM_UL                             55
#define C_ABE_FW_TASK_IO_BT_VX_UL                           56
#define C_ABE_FW_TASK_IO_MM_UL                              57
#define C_ABE_FW_TASK_IO_MM_UL2                             58
#define C_ABE_FW_TASK_IO_VX_UL                              59
#define C_ABE_FW_TASK_IO_MM_DL                              60
#define C_ABE_FW_TASK_IO_VX_DL                              61
#define C_ABE_FW_TASK_IO_TONES_DL                           62
#define C_ABE_FW_TASK_IO_VIB_DL                             63
#define C_ABE_FW_TASK_IO_BT_VX_DL                           64
#define C_ABE_FW_TASK_IO_PDM_DL                             65
#define C_ABE_FW_TASK_IO_MM_EXT_OUT                         66
#define C_ABE_FW_TASK_IO_MM_EXT_IN                          67
#define C_ABE_FW_TASK_IO_TDM_OUT                            68
#define C_ABE_FW_TASK_IO_TDM_IN                             69
#define C_ABE_FW_TASK_DEBUG_IRQFIFO                         70
#define C_ABE_FW_TASK_EchoMixer                             71
#define C_ABE_FW_TASK_SDTMixer                              72
#define C_ABE_FW_TASK_DL1Mixer                              73
#define C_ABE_FW_TASK_DL2Mixer                              74
#define C_ABE_FW_TASK_VXRECMixer                            75
#define C_ABE_FW_TASK_ULMixer                               76
#define C_ABE_FW_TASK_VIBRA_PACK                            77
#define C_ABE_FW_TASK_VX_DL_8_48_0SR                        78
#define C_ABE_FW_TASK_VX_DL_16_48_0SR                       79
#define C_ABE_FW_TASK_BT_UL_8_48_0SR                        80
#define C_ABE_FW_TASK_BT_UL_16_48_0SR                       81
#define C_ABE_FW_TASK_IHF_48_96_0SR                         82
#define C_ABE_FW_TASK_EARP_48_96_0SR                        83
#define C_ABE_FW_TASK_AMIC_SPLIT                            84
#define C_ABE_FW_TASK_DMIC1_SPLIT                           85
#define C_ABE_FW_TASK_DMIC2_SPLIT                           86
#define C_ABE_FW_TASK_DMIC3_SPLIT                           87
#define C_ABE_FW_TASK_VXREC_SPLIT                           88
#define C_ABE_FW_TASK_BT_UL_SPLIT                           89
#define C_ABE_FW_TASK_MM_SPLIT                              90
#define C_ABE_FW_TASK_DL2_APS_SPLIT                         91
#define C_ABE_FW_TASK_VIBRA_SPLIT                           92
#define C_ABE_FW_TASK_MM_EXT_IN_SPLIT                       93
#define C_ABE_FW_TASK_EANC_FBK_SPLIT                        94
#define C_ABE_FW_TASK_MIC4_SPLIT                            95
#define C_ABE_FW_TASK_VX_UL_ROUTING                         96
#define C_ABE_FW_TASK_MM_UL2_ROUTING                        97
#define C_ABE_FW_TASK_VIBRA1                                98
#define C_ABE_FW_TASK_VIBRA2                                99
#define C_ABE_FW_TASK_BT_UL_16_48                           100
#define C_ABE_FW_TASK_BT_UL_8_48                            101
#define C_ABE_FW_TASK_BT_DL_48_16                           102
#define C_ABE_FW_TASK_BT_DL_48_8                            103
#define C_ABE_FW_TASK_VX_DL_16_48                           104
#define C_ABE_FW_TASK_VX_DL_8_48                            105
#define C_ABE_FW_TASK_VX_UL_48_16                           106
#define C_ABE_FW_TASK_VX_UL_48_8                            107
#define C_ABE_FW_TASK_DBG_SYNC                              108
#define C_ABE_FW_TASK_APS_DL1_IRQs                          109
#define C_ABE_FW_TASK_APS_DL2_L_IRQs                        110
#define C_ABE_FW_TASK_APS_DL2_R_IRQs                        111
#define C_ABE_FW_TASK_AMIC_96_48_LP                         112
#define C_ABE_FW_TASK_DMIC1_96_48_LP                        113
#define C_ABE_FW_TASK_DMIC2_96_48_LP                        114
#define C_ABE_FW_TASK_DMIC3_96_48_LP                        115
#define C_ABE_FW_TASK_INIT_FW_MEMORY                        116
#define C_ABE_FW_TASK_DEBUGTRACE_VX_ASRCs                   117

#endif /* _ABE_TASKID_H_ */
